(function(t) {
	function componentToHex(c) {
		if (c==undefined) return 0;
		var hex = c.toString(16);
		return hex.length == 1 ? "0" + hex : hex;
	}
	function rgbToHex(r, g, b) {
		return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
	}
    var g = {
        version: "ILDA.JS"
    }
      , j = {
        THREE_DIMENSIONAL: 0,
        TWO_DIMENSIONAL: 1,
        COLOR_TABLE: 2,
        TRUECOLOR_TABLE: 3,
        THREE_DIMENSIONAL_TRUE_COLOR: 4,
        TWO_DIMENSIONAL_TRUE_COLOR: 5,
        UNKNOWN: 99
    }
      , p = function() {
        this.color = this.z = this.y = this.x = 0;
        this.last = this.blanking = !1
    };
    g.Point = p;
    var q = function() {
        this.b = this.g = this.r = 0
    };
    g.Color = q;
    var r = function() {
        this.type = j.UNKNOWN;
        this.company = this.name = "";
        this.index = 0;
        this.points = [];
        this.total = this.head = 0;
        this.colors = []
    }
    , s = function() {
        this.sections = []
    };
    g.Section = r;
    g.SectionTypes = j;
    g.File = s;
    var k = function(c) {
        this.bytes = c || [];
        this.position = 0;
        this.length = this.bytes.length
    };
    k.prototype.seek = function(c) {
        this.position = c
    }
    ;
    k.prototype.eof = function() {
        return this.position >= this.length
    }
    ;
    k.prototype.readString = function(c) {
        for (var h = "", b = 0; b < c; b++) {
            var j = this.readByte();
            0 < j && 127 > j && (h += String.fromCharCode(j))
        }
        return h.trim()
    }
    ;
    k.prototype.readByte = function() {
        var c = this.bytes[this.position];
        this.position++;
        return c
    }
    ;
    k.prototype.readShort = function() {
        var c = this.readByte()
          , h = this.readByte();
        return (c << 8) + h
    }
    ;
    k.prototype.readSignedShort = function() {
        var c = this.readByte()
          , h = this.readByte()
          , c = (c << 8) + h;
        32768 < c && (c = -(65535 - c));
        return c
    }
    ;
    k.prototype.readLong = function() {
        var c = this.readByte()
          , h = this.readByte()
          , b = this.readByte();
        return this.readByte() + (b << 8) + (h << 16) + (c << 24)
    }
    ;
    g.Reader = {
        fromByteArray: function(c, h) {
            for (var b, g = new s, a = new k(c); !a.eof() && "ILDA" == a.readString(4); ) {
                var e = new r;
                var reserved=a.readString(3); // not used
                //console.log("reserved:",reserved);
                e.type = a.readByte();
                switch (e.type) {
                case j.THREE_DIMENSIONAL_TRUE_COLOR:
                    e.name = a.readString(8);
                    e.company = a.readString(8);
                    var f = a.readShort();
                    e.index = a.readShort();
                    e.total = a.readShort();
                    e.head = a.readByte();
                    a.readByte();
                    for (b = 0; b < f; b++) {
                        var d = new p;
                        d.x = a.readSignedShort();
                        d.y = a.readSignedShort();
                        d.z = a.readSignedShort();
                        var l = a.readByte(); // blanking and last point
                        d.blanking = (l & 128);
                        d.last = (l & 256);
                        bl=a.readByte(); //blue
                        gn=a.readByte(); //green
                        rd=a.readByte(); //red
                        d.color=rgbToHex(rd, gn, bl);
                        e.points.push(d);
                    }
                break;
                case j.TWO_DIMENSIONAL_TRUE_COLOR:
                    e.name = a.readString(8);
                    e.company = a.readString(8);
                    var f = a.readShort();
                    e.index = a.readShort();
                    e.total = a.readShort();
                    e.head = a.readByte();
                    a.readByte();
                    for (b = 0; b < f; b++) {
                        var d = new p;
                        d.x = a.readSignedShort();
                        d.y = a.readSignedShort();
                        var l = a.readByte(); // blanking and last point
                        d.blanking = (l & 128);
                        d.last =  (l & 256);
                        bl=a.readByte(); //blue
                        gn=a.readByte(); //green
                        rd=a.readByte(); //red
						//console.log("color 1",b,rd,gn,bl,rgbToHex(rd, gn, bl));
                        d.color=rgbToHex(rd, gn, bl);
                        e.points.push(d);
                    }
                break;
                case j.THREE_DIMENSIONAL:
                    e.name = a.readString(8);
                    e.company = a.readString(8);
                    var f = a.readShort();
                    e.index = a.readShort();
                    e.total = a.readShort();
                    e.head = a.readByte();
                    a.readByte();
                    for (b = 0; b < f; b++) {
                        var d = new p;
                        d.x = a.readSignedShort();
                        d.y = a.readSignedShort();
                        d.z = a.readSignedShort();
                        var l = a.readShort();
                        d.color = l >> 0 & 127;
                        d.blanking = 16384 == (l & 16384);
                        d.last = 32768 == (l & 32768);
                        e.points.push(d)
                    }
                    break;
                case j.TWO_DIMENSIONAL:
                    e.name = a.readString(8);
                    e.company = a.readString(8);
                    f = a.readShort();
                    e.index = a.readShort();
                    e.total = a.readShort();
                    e.head = a.readByte();
                    a.readByte();
                    for (b = 0; b < f; b++)
                        d = new p,
                        d.x = a.readSignedShort(),
                        d.y = a.readSignedShort(),
                        l = a.readShort(),
                        d.color = l >> 0 & 127,
                        d.blanking = 16384 == (l & 16384),
                        d.last = 32768 == (l & 32768),
                        e.points.push(d);
                    break;
                case j.COLOR_TABLE:
                    e.name = a.readString(8);
                    e.company = a.readString(8);
                    f = a.readShort();
                    e.index = a.readShort();
                    a.readByte();
                    a.readByte();
                    e.head = a.readByte();
                    a.readByte();
                    for (b = 0; b < f; b++)
                        d = new q,
                        d.r = a.readByte(),
                        d.g = a.readByte(),
                        d.b = a.readByte(),
                        e.colors.push(d);
                    break;
                case j.TRUECOLOR_TABLE:
                    a.readLong();
                    f = a.readLong();
                    for (b = 0; b < f; b++)
                        d = new q,
                        d.r = a.readByte(),
                        d.g = a.readByte(),
                        d.b = a.readByte(),
                        e.colors.push(d)
                }
                g.sections.push(e)
            }
            h(g)
        }
    };
    var n = function(c) {
        this.animation = c || new Animation
    };
    n.prototype.addAnimation = function(c) {
        for (frame in c.frames)
            this.addFrame(frame)
    }
    ;
    n.prototype.addFrame = function(c) {
        this.animation.addFrame(c)
    }
    ;
    var m = function() {
        this.bytes = []
    };
    m.prototype.writeByte = function(c) {
        this.bytes.push(c)
    }
    ;
    m.prototype.writeShort = function(c) {
        this.writeByte(c >> 8 & 255);
        this.writeByte(c >> 0 & 255)
    }
    ;
    m.prototype.writeSignedShort = function(c) {
        0 > c && (c = 65535 + c);
        this.writeByte(c >> 8 & 255);
        this.writeByte(c >> 0 & 255)
    }
    ;
    m.prototype.writeLong = function(c) {
        this.writeByte(c >> 24 & 255);
        this.writeByte(c >> 16 & 255);
        this.writeByte(c >> 8 & 255);
        this.writeByte(c >> 0 & 255)
    }
    ;
    m.prototype.writeString = function(c, h) {
        for (var b = 0; b < h; b++)
            b < c.length ? this.writeByte(c.charCodeAt(b)) : this.writeByte(0)
    }
    ;
    n.toByteArray = function(c, h) {
        var b = new m, g;
        for (g in c.sections) {
            var a = c.sections[g];
            switch (a.type) {
            case j.THREE_DIMENSIONAL:
                b.writeString("ILDA", 4);
                b.writeLong(a.type);
                b.writeString(a.name, 8);
                b.writeString(a.company, 8);
                b.writeShort(a.points.length);
                b.writeShort(a.index);
                b.writeShort(a.total);
                b.writeByte(a.head);
                b.writeByte(0);
                for (var e = 0; e < a.points.length; e++) {
                    var f = a.points[e];
                    b.writeSignedShort(f.x);
                    b.writeSignedShort(f.y);
                    b.writeSignedShort(f.z);
                    var d = 0
                      , d = d | f.color & 127;
                    f.blanking && (d |= 16384);
                    if (f.last || e == a.points.length - 1)
                        d |= 32768;
                    b.writeShort(d)
                }
                break;
            case j.TWO_DIMENSIONAL:
                b.writeString("ILDA", 4);
                b.writeLong(a.type);
                b.writeString(a.name, 8);
                b.writeString(a.company, 8);
                b.writeShort(a.points.length);
                b.writeShort(a.index);
                b.writeShort(a.total);
                b.writeByte(a.head);
                b.writeByte(0);
                for (e = 0; e < a.points.length; e++) {
                    f = a.points[e];
                    b.writeSignedShort(f.x);
                    b.writeSignedShort(f.y);
                    d = 0;
                    d |= f.color & 127;
                    f.blanking && (d |= 16384);
                    if (f.last || e == a.points.length - 1)
                        d |= 32768;
                    b.writeShort(d)
                }
                break;
            case j.COLOR_TABLE:
                b.writeString("ILDA", 4);
                b.writeLong(a.type);
                b.writeString(a.name, 8);
                b.writeString(a.company, 8);
                b.writeShort(a.colors.length);
                b.writeShort(a.index);
                b.writeByte(0);
                b.writeByte(0);
                b.writeByte(a.head);
                b.writeByte(0);
                for (e = 0; e < a.colors.length; e++)
                    f = a.colors[e],
                    b.writeByte(f.r),
                    b.writeByte(f.g),
                    b.writeByte(f.b);
                break;
            case j.TRUECOLOR_TABLE:
                b.writeString("ILDA", 4);
                b.writeLong(a.type);
                b.writeLong(3 * a.colors.length + 4);
                b.writeLong(a.colors.length);
                for (e = 0; e < a.colors.length; e++)
                    f = a.colors[e],
                    b.writeByte(f.r),
                    b.writeByte(f.g),
                    b.writeByte(f.b)
            }
        }
        h(b.bytes)
    }
    ;
    g.Writer = n;
    g.Utils = {};
    t.ILDA = g
})(this);
